#include <stdio.h>
#include <stdlib.h>
int main()
{
    int suma = 0, n, m, navijaci[100], broj_niza=0, q, xq, yq, brq;
    scanf("%d%d", &n, &m);
    for(int i=0; i<n*m; i++){
        scanf("%d", &navijaci[i]);
    }
    scanf("%d", &q);
    for(int j=0; j<q; j++){
        scanf("%d%d", &xq, &yq);
    }
    brq=xq*m+yq;
    while(broj_niza<n*m){
        if(broj_niza!=brq&&broj_niza!=0&&broj_niza%(m-1)==0){
            suma=suma+navijaci[broj_niza];
            broj_niza=broj_niza+m;
        }
        else if(broj_niza!=brq&&broj_niza>(n-1)*m-1&&broj_niza<n*m-1){
            suma=suma+navijaci[broj_niza];
            broj_niza=broj_niza+1;
        }
        else{
            if(broj_niza!=brq&&navijaci[broj_niza+1]<navijaci[broj_niza+m]){
                suma=suma+navijaci[broj_niza];
                broj_niza+=1;
            }
            else{
                suma=suma+navijaci[broj_niza+m];
                broj_niza=broj_niza+m;
            }
        }
    }
    printf("%d", suma);
    return 0;
}